﻿using Infragistics.Controls.Editors;
using Infragistics.Controls.Editors.Primitives;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Interactivity;
using MahApps.Metro.Controls;
using TestHdadmProject.CustomControls;
using System.Diagnostics;
using System.Windows.Data;
using System.Windows;

namespace TestHdadmProject.Behaviors
{
    public class XamEditComboValueBehaviour : Behavior<HDADMXamComboEditor>
    {
        protected override void OnAttached()
        {
            base.OnAttached();
            AssociatedObject.Loaded += AssociatedObject_Loaded;
         
        }

        protected override void OnDetaching()
        {
            var tb = (SpecializedTextBox)Infragistics.Windows.Utilities.GetDescendantFromType(AssociatedObject, typeof(SpecializedTextBox), false); //GetDescendantFromName(AssociatedObject, "TextBoxPresenter");
            if (tb != null)
            {
                tb.TextChanged -= tb_TextChanged;
                tb.GotFocus -= tb_GotFoccused;
                tb.LostFocus -= tb_LostFocus;
            }
            AssociatedObject.SelectionChanged -= AssociatedObject_SelectionChanged;
        }

        void AssociatedObject_Loaded(object sender, System.Windows.RoutedEventArgs e)
        {
            AssociatedObject.Loaded -= AssociatedObject_Loaded;
            AssociatedObject.SelectionChanged += AssociatedObject_SelectionChanged;
            var tb = (SpecializedTextBox)Infragistics.Windows.Utilities.GetDescendantFromType(AssociatedObject, typeof(SpecializedTextBox), false); //GetDescendantFromName(AssociatedObject, "TextBoxPresenter");
            if (tb != null)
            {
                tb.TextChanged += tb_TextChanged;
                tb.GotFocus += tb_GotFoccused;
                tb.LostFocus += tb_LostFocus;
                
                Binding bind = new Binding();
                bind.Path = new PropertyPath("SelectedPanelistValue");
                bind.Source = AssociatedObject;
                bind.Mode = BindingMode.TwoWay;
                bind.UpdateSourceTrigger = UpdateSourceTrigger.PropertyChanged;
                BindingOperations.SetBinding(tb, TextBox.TextProperty, bind);
            }
            base.OnDetaching();
        }

        void AssociatedObject_SelectionChanged(object sender, Infragistics.Controls.Editors.SelectionChangedEventArgs e)
        {
            if (AssociatedObject.SelectedItem != null) 
            {
                AssociatedObject.IsDropDownOpen = false;
            }
        }

        void tb_LostFocus(object sender, System.Windows.RoutedEventArgs e)
        {
            AssociatedObject.IsDropDownOpen = false;
        }

        private void tb_GotFoccused(object sender, System.Windows.RoutedEventArgs e)
        {
            var tb = (SpecializedTextBox)Infragistics.Windows.Utilities.GetDescendantFromType(AssociatedObject, typeof(SpecializedTextBox), false); //GetDescendantFromName(AssociatedObject, "TextBoxPresenter");
            if (string.IsNullOrEmpty(tb.Text))
            { 
                AssociatedObject.IsDropDownOpen = true;
            }
        }

        void tb_TextChanged(object sender, System.Windows.Controls.TextChangedEventArgs e)
        {
            SpecializedTextBox tb = sender as SpecializedTextBox;

            if (string.IsNullOrEmpty(tb.Text))
            {
                this.AssociatedObject.IsDropDownOpen = true;
                return;
            }
        }
    }
}
